# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/01_utils.ipynb.

# %% auto 0
__all__ = ['getidx', 'getexp', 'getsuf', 'getnum', 'format']

# %% ../nbs/01_utils.ipynb 5
import os, math
from dataclasses import KW_ONLY, dataclass, field
from enum import Enum, StrEnum, IntEnum
from typing import Union, List, Optional, Iterable

# %% ../nbs/01_utils.ipynb 7
from .units import (KILO, UNITS)
from pstr.nchr.core import SPACE
from pstr.fmts.byte import (getidx, getexp, getsuf, getnum, fmtbyte)

# %% ../nbs/01_utils.ipynb 9
def getidx(size: int = 1, base: int = KILO, units: Iterable = UNITS) -> int:
    '''Gets the index of the unit for a given size and base'''
    return getidx(size, base, units)

def getexp(size: int = 1, base: int = KILO, units: Iterable = UNITS):
    '''Gets the power of the unit for a given size and base'''
    return getexp(size, base, units)

def getsuf(size: int = 1, base: int = KILO, units: Iterable = UNITS):
    '''Returns the unit suffix for a given size and base'''    
    return getsuf(size, base, units)    

def getnum(size: int = 1, base: int = KILO, precision: Optional[int] = 1, units: Iterable = UNITS):
    '''Returns the unit suffix for a given size and base'''
    return getnum(size, base, precision, units)

def format(size: int = 1, base: int = KILO, sep: Optional[str] = SPACE, precision: Optional[int] = 1, units: Iterable = UNITS):    
    return fmtbyte(size, base, sep, precision, units)
